%
% Politecnico di Milano
% Corso Informatica B - Prof. Loiacono
% Esercizi di: Alessandro A. Nacci
% Per contatti: alessandro.nacci@mail.polimi.it
% ------------------------------------
%	ESERCIZIO 2
%	CONTROLLA MATRICI
%

% Scrivere una funzione controllaMatrici con:
% 	Due matrici A e B in ingresso
%	Due valori r e c in uscita
%
% La funzione deve eseguire le seguenti operazioni:
% 
%	1)  Verificare che le due matrici abbiano le stesse dimensioni;
% 		in caso contrario, restituire r=-1 e c=-1
% 	2) 	Calcolare il valore r come il numero di righe che in entrambe le matrici
%		contengono soltanto numeri compresi tra 1 e 5
%	3)  Calcolare il valore c come il numero di colonne che in entrambe le matrici
%		contengono soltanto numeri compresi tra 1 e 5 

% Per eseguire i punti 2 e 3 si richiede di utilizzare la funzione
% controllaVettore definita nell’esercizio precedente

% Esempio:
%	   M 		 	N
%	1 2 2 1		2 1 3 4		r = 1 (la riga 1 soddisfa la condizione)
% 	5 7 2 8		1 5 4 4		c = 2 (le colonne 1 e 3 soddisfano la condizione)
%	3 3 3 4		1 6 1 2


function [r c] = controllaMatrici(A, B)

% Se le matrici non hanno le stesse dimensioni restituiamo una coppia di (-1)
if ~(size(A,1)==size(B,1) && size(A,2)==size(B,2))
	r=-1;
	c=-1;
else
	% Altrimenti eseguiamo i calcoli richiesti
	% Inizializziamo r a zero, e consideriamo una riga per volta
	r=0;
	for ii=1:size(A,1)
		% Se entrambe le righe ii-esime verificano la condizione, incrementiamo r
		if controllaVettore(A(ii,:)) && controllaVettore(B(ii,:))
			r = r+1;
		end
	end
	
	% Facciamo lo stesso con le colonne
	c=0;
	for ii=1:size(A,2)
		if controllaVettore(A(:,ii)) && controllaVettore(B(:,ii))
			c = c+1;
		end
	end
end


% APPROFONDIMENTO: Provare a generalizzare la funzione controllaVettore
% in modo tale che sia in grado di lavorare anche con intervalli diversi
% dall'intervallo (1,5)
